package FilmCameraPackage
{
	function GameConnection::onClientEnterGame(%this)
	{
		Parent::onClientEnterGame(%this);

		%this.filmCameraCount = 0;
		%this.camera.filmCameraName = "\c3Work Camera";
	}

	function GameConnection::onClientLeaveGame(%this)
	{
		for (%i = 0; %i < %this.filmCameraCount; %i++)
		{
			%this.filmCamera[%i].delete();
			%this.filmCamera[%i] = "";
		}

		%this.filmCameraCount = "";
		Parent::onClientLeaveGame(%this);
	}

	function GameConnection::setControlObject(%this, %control)
	{
		Parent::setControlObject(%this, %control);
		%this.updateFilmCameraDisplay();
	}
};

activatePackage("FilmCameraPackage");

function GameConnection::findFilmCamera(%this, %name)
{
	for (%i = 0; %i < %this.filmCameraCount; %i++)
	{
		if (%this.filmCamera[%i].filmCameraName $= %name)
		{
			return %this.filmCamera[%i];
		}
	}

	return 0;
}

function GameConnection::updateFilmCameraDisplay(%this, %noClear)
{
	%control = %this.getControlObject();

	if (!(%control.getType() & $TypeMasks::CameraObjectType))
	{
		if (!%noClear)
		{
			commandToClient(%this, 'ClearBottomPrint');
		}

		return;
	}

	//%this.bottomPrint("\c6Camera: \c3" @ %control.filmcameraName, 0, 1);
}

function serverCmdFC(%client, %a, %b, %c, %d, %noCreate)
{
	if (!%client.isAdmin && !%client.isSuperAdmin)
	{
		%client.chatMessage("\c6You must be Admin or Super Admin to use film cameras.");
		return;
	}

	%name = stripMLControlChars(%a SPC %b SPC %c SPC %d);
	%camera = %client.findFilmCamera(%name);

	if (isObject(%camera))
	{
		%client.setControlObject(%camera);
		return;
	}

	if (%noCreate)
	{
		%client.chatMessage("\c6Unable to switch to film camera.");
		return;
	}

	if (%name $= "")
	{
		%client.chatMessage("\c6You cannot create a film camera with a blank name.");
		return;
	}

	%control = %client.getControlObject();

	if (!(%control.getType() & $TypeMasks::CameraObjectType))
	{
		%client.chatMessage("\c6No such film camera exists, and you must be controlling a camera to create a new one.");
		return;
	}

	%camera = %control.copy();

	if (!isObject(%camera))
	{
		%client.chatMessage("\c6Unable to create a new film camera.");
		return;
	}

	%camera.filmCameraName = %name;
	%camera.setTransform(%control.getTransform());

	%client.filmCamera[%client.filmCameraCount] = %camera;
	%client.filmCameraCount++;

	%client.chatMessage("\c6Created new film camera.");
	serverCmdFC(%client, %a, %b, %c, %d, 1);
}

function SimObject::copy(%this)
{
	%name = %this.getName();
	%group = %this.getGroup();

	%this.setName("_simObjectCopyBase");

	%obj = new (%this.getClassName())("" : _simObjectCopyBase)
	{
		__isCopy = 1;
	};

	%this.setName(%name);

	if (!isObject(%obj))
	{
		return 0;
	}

	%obj.setName(%name);

	if (isObject(%group) && !%group.isMember(%obj))
	{
		%group.add(%obj);
	}

	return %obj;
}